libetonyek::IWORKTable Class Reference documentation

libetonyek::IWORKTable Class Reference

`#include <IWORKTable.h>`

## Classes
struct | Cell

## Public Types
enum | CellType { CELL_TYPE_BODY , CELL_TYPE_ALTERNATE_BODY , CELL_TYPE_COLUMN_HEADER , CELL_TYPE_ROW_HEADER , CELL_TYPE_ROW_FOOTER }

## Public Member Functions
| IWORKTable (const IWORKTableNameMapPtr_t &tableNameMap, IWORKFormatNameMap &formatNameMap, const IWORKLanguageManager &langManager)
void | setRecorder (const std::shared_ptr< IWORKTableRecorder > &recorder)
const std::shared_ptr< IWORKTableRecorder > & | getRecorder () const
void | setName (std::string const &name)
void | setSize (unsigned columns, unsigned rows)
void | setHeaders (unsigned headerColumns, unsigned headerRows, unsigned footerRows)
void | setBandedRows (bool banded=true)
void | setRepeated (bool columns, bool rows)
void | setOrder (int order)
void | setStyle (const IWORKStylePtr_t &style)
void | setSizes (const IWORKColumnSizes_t &columnSizes, const IWORKRowSizes_t &rowSizes)
void | setBorders (const IWORKGridLineMap_t &verticalLines, const IWORKGridLineMap_t &horizontalLines)
void | setBorders (const IWORKGridLineMap_t &verticalLeftLines, const IWORKGridLineMap_t &verticalRightLines, const IWORKGridLineMap_t &horizontalTopLines, const IWORKGridLineMap_t &horizontalBottomLines)
void | setComment (unsigned column, unsigned row, IWORKOutputElements const &text)
void | insertCell (unsigned column, unsigned row, const boost::optional< std::string > &value=boost::none, const std::shared_ptr< IWORKText > &text=std::shared_ptr< IWORKText >(), const boost::optional< IWORKDateTimeData > &dateTime=boost::none, unsigned columnSpan=1, unsigned rowSpan=1, const IWORKFormulaPtr_t &formula=IWORKFormulaPtr_t(), const boost::optional< unsigned > &formulaHC=boost::none, const IWORKStylePtr_t &style=IWORKStylePtr_t(), IWORKCellType type=IWORK_CELL_TYPE_TEXT)
void | insertCoveredCell (unsigned column, unsigned row)
void | draw (const librevenge::RVNGPropertyList &tableProps, IWORKOutputElements &elements, bool drawAsSimpleTable)
void | setDefaultCellStyle (CellType type, const IWORKStylePtr_t &style)
void | setDefaultLayoutStyle (CellType type, const IWORKStylePtr_t &style)
void | setDefaultParagraphStyle (CellType type, const IWORKStylePtr_t &style)
boost::optional< int > | getOrder () const
IWORKStylePtr_t | getStyle () const
IWORKStylePtr_t | getDefaultCellStyle (unsigned column, unsigned row) const
IWORKStylePtr_t | getDefaultLayoutStyle (unsigned column, unsigned row) const
IWORKStylePtr_t | getDefaultParagraphStyle (unsigned column, unsigned row) const

## Private Types
typedef std::map< unsigned, Cell > | Row_t
typedef std::deque< Row_t > | Table_t

## Private Member Functions
IWORKStylePtr_t | getDefaultStyle (unsigned column, unsigned row, const IWORKStylePtr_t *group) const
boost::optional< std::string > | writeFormat (IWORKOutputElements &elements, const IWORKStylePtr_t &style, const IWORKCellType type, boost::optional< std::string > &rvngValueType)

## Private Attributes
const IWORKTableNameMapPtr_t | m_tableNameMap
const IWORKLanguageManager & | m_langManager
IWORKFormatNameMap & | m_formatNameMap
std::map< std::pair< unsigned, unsigned >, IWORKOutputElements > | m_commentMap
Table_t | m_table
IWORKStylePtr_t | m_style
boost::optional< std::string > | m_name
boost::optional< int > | m_order
IWORKColumnSizes_t | m_columnSizes
IWORKRowSizes_t | m_rowSizes
IWORKGridLineMap_t | m_verticalLines
IWORKGridLineMap_t | m_verticalRightLines
IWORKGridLineMap_t | m_horizontalLines
IWORKGridLineMap_t | m_horizontalBottomLines
unsigned | m_rows
unsigned | m_columns
unsigned | m_headerRows
unsigned | m_footerRows
unsigned | m_headerColumns
bool | m_bandedRows
bool | m_headerRowsRepeated
bool | m_headerColumnsRepeated
IWORKStylePtr_t | m_defaultCellStyles [5]
IWORKStylePtr_t | m_defaultLayoutStyles [5]
IWORKStylePtr_t | m_defaultParaStyles [5]
std::shared_ptr< IWORKTableRecorder > | m_recorder

## Member Typedef Documentation

## ◆ Row_t

typedef std::map<unsigned, Cell> libetonyek::IWORKTable::Row_t
| private

## ◆ Table_t

typedef std::deque<Row_t> libetonyek::IWORKTable::Table_t
| private

## Member Enumeration Documentation

## ◆ CellType

enum libetonyek::IWORKTable::CellType

Enumerator
CELL_TYPE_BODY |
CELL_TYPE_ALTERNATE_BODY |
CELL_TYPE_COLUMN_HEADER |
CELL_TYPE_ROW_HEADER |
CELL_TYPE_ROW_FOOTER |

## Constructor & Destructor Documentation

## ◆ IWORKTable()

libetonyek::IWORKTable::IWORKTable | ( | const IWORKTableNameMapPtr_t & | tableNameMap,
|  | IWORKFormatNameMap & | formatNameMap,
|  | const IWORKLanguageManager & | langManager )
| explicit

## Member Function Documentation

## ◆ draw()

void libetonyek::IWORKTable::draw | ( | const librevenge::RVNGPropertyList & | tableProps,
|  | IWORKOutputElements & | elements,
|  | bool | drawAsSimpleTable )

## ◆ getDefaultCellStyle()

IWORKStylePtr_t libetonyek::IWORKTable::getDefaultCellStyle | ( | unsigned | column,
|  | unsigned | row ) const

Referenced by draw(), and insertCell().

## ◆ getDefaultLayoutStyle()

IWORKStylePtr_t libetonyek::IWORKTable::getDefaultLayoutStyle | ( | unsigned | column,
|  | unsigned | row ) const

Referenced by insertCell().

## ◆ getDefaultParagraphStyle()

IWORKStylePtr_t libetonyek::IWORKTable::getDefaultParagraphStyle | ( | unsigned | column,
|  | unsigned | row ) const

Referenced by draw(), and insertCell().

## ◆ getDefaultStyle()

IWORKStylePtr_t libetonyek::IWORKTable::getDefaultStyle | ( | unsigned | column,
|  | unsigned | row,
|  | const IWORKStylePtr_t * | group ) const
| private

Referenced by getDefaultCellStyle(), getDefaultLayoutStyle(), and getDefaultParagraphStyle().

## ◆ getOrder()

boost::optional< int > libetonyek::IWORKTable::getOrder | ( |  | ) | const

## ◆ getRecorder()

const std::shared_ptr< IWORKTableRecorder > & libetonyek::IWORKTable::getRecorder | ( |  | ) | const

## ◆ getStyle()

IWORKStylePtr_t libetonyek::IWORKTable::getStyle | ( |  | ) | const

## ◆ insertCell()

void libetonyek::IWORKTable::insertCell | ( | unsigned | column,
|  | unsigned | row,
|  | const boost::optional< std::string > & | value = boost::none,
|  | const std::shared_ptr< IWORKText > & | text = std::shared_ptr<IWORKText>(),
|  | const boost::optional< IWORKDateTimeData > & | dateTime = boost::none,
|  | unsigned | columnSpan = 1,
|  | unsigned | rowSpan = 1,
|  | const IWORKFormulaPtr_t & | formula = IWORKFormulaPtr_t(),
|  | const boost::optional< unsigned > & | formulaHC = boost::none,
|  | const IWORKStylePtr_t & | style = IWORKStylePtr_t(),
|  | IWORKCellType | type = IWORK_CELL_TYPE_TEXT )

## ◆ insertCoveredCell()

void libetonyek::IWORKTable::insertCoveredCell | ( | unsigned | column,
|  | unsigned | row )

## ◆ setBandedRows()

void libetonyek::IWORKTable::setBandedRows | ( | bool | banded = true | ) |

## ◆ setBorders() [1/2]

void libetonyek::IWORKTable::setBorders | ( | const IWORKGridLineMap_t & | verticalLeftLines,
|  | const IWORKGridLineMap_t & | verticalRightLines,
|  | const IWORKGridLineMap_t & | horizontalTopLines,
|  | const IWORKGridLineMap_t & | horizontalBottomLines )

## ◆ setBorders() [2/2]

void libetonyek::IWORKTable::setBorders | ( | const IWORKGridLineMap_t & | verticalLines,
|  | const IWORKGridLineMap_t & | horizontalLines )

## ◆ setComment()

void libetonyek::IWORKTable::setComment | ( | unsigned | column,
|  | unsigned | row,
|  | IWORKOutputElements const & | text )

## ◆ setDefaultCellStyle()

void libetonyek::IWORKTable::setDefaultCellStyle | ( | CellType | type,
|  | const IWORKStylePtr_t & | style )

## ◆ setDefaultLayoutStyle()

void libetonyek::IWORKTable::setDefaultLayoutStyle | ( | CellType | type,
|  | const IWORKStylePtr_t & | style )

## ◆ setDefaultParagraphStyle()

void libetonyek::IWORKTable::setDefaultParagraphStyle | ( | CellType | type,
|  | const IWORKStylePtr_t & | style )

## ◆ setHeaders()

void libetonyek::IWORKTable::setHeaders | ( | unsigned | headerColumns,
|  | unsigned | headerRows,
|  | unsigned | footerRows )

## ◆ setName()

void libetonyek::IWORKTable::setName | ( | std::string const & | name | ) |

## ◆ setOrder()

void libetonyek::IWORKTable::setOrder | ( | int | order | ) |

## ◆ setRecorder()

void libetonyek::IWORKTable::setRecorder | ( | const std::shared_ptr< IWORKTableRecorder > & | recorder | ) |

## ◆ setRepeated()

void libetonyek::IWORKTable::setRepeated | ( | bool | columns,
|  | bool | rows )

## ◆ setSize()

void libetonyek::IWORKTable::setSize | ( | unsigned | columns,
|  | unsigned | rows )

## ◆ setSizes()

void libetonyek::IWORKTable::setSizes | ( | const IWORKColumnSizes_t & | columnSizes,
|  | const IWORKRowSizes_t & | rowSizes )

## ◆ setStyle()

void libetonyek::IWORKTable::setStyle | ( | const IWORKStylePtr_t & | style | ) |

## ◆ writeFormat()

boost::optional< std::string > libetonyek::IWORKTable::writeFormat | ( | IWORKOutputElements & | elements,
|  | const IWORKStylePtr_t & | style,
|  | const IWORKCellType | type,
|  | boost::optional< std::string > & | rvngValueType )
| private

Referenced by draw().

## Member Data Documentation

## ◆ m_bandedRows

bool libetonyek::IWORKTable::m_bandedRows
| private

Referenced by getDefaultStyle(), IWORKTable(), and setBandedRows().

## ◆ m_columns

unsigned libetonyek::IWORKTable::m_columns
| private

Referenced by IWORKTable(), and setSize().

## ◆ m_columnSizes

IWORKColumnSizes_t libetonyek::IWORKTable::m_columnSizes
| private

Referenced by draw(), insertCell(), insertCoveredCell(), IWORKTable(), and setSizes().

## ◆ m_commentMap

std::map<std::pair<unsigned, unsigned>, IWORKOutputElements> libetonyek::IWORKTable::m_commentMap
| private

Referenced by draw(), IWORKTable(), and setComment().

## ◆ m_defaultCellStyles

IWORKStylePtr_t libetonyek::IWORKTable::m_defaultCellStyles[5]
| private

Referenced by draw(), getDefaultCellStyle(), and setDefaultCellStyle().

## ◆ m_defaultLayoutStyles

IWORKStylePtr_t libetonyek::IWORKTable::m_defaultLayoutStyles[5]
| private

Referenced by draw(), getDefaultLayoutStyle(), and setDefaultLayoutStyle().

## ◆ m_defaultParaStyles

IWORKStylePtr_t libetonyek::IWORKTable::m_defaultParaStyles[5]
| private

Referenced by draw(), getDefaultParagraphStyle(), and setDefaultParagraphStyle().

## ◆ m_footerRows

unsigned libetonyek::IWORKTable::m_footerRows
| private

Referenced by getDefaultStyle(), IWORKTable(), and setHeaders().

## ◆ m_formatNameMap

IWORKFormatNameMap& libetonyek::IWORKTable::m_formatNameMap
| private

Referenced by IWORKTable(), and writeFormat().

## ◆ m_headerColumns

unsigned libetonyek::IWORKTable::m_headerColumns
| private

Referenced by draw(), getDefaultStyle(), IWORKTable(), and setHeaders().

## ◆ m_headerColumnsRepeated

bool libetonyek::IWORKTable::m_headerColumnsRepeated
| private

Referenced by IWORKTable(), and setRepeated().

## ◆ m_headerRows

unsigned libetonyek::IWORKTable::m_headerRows
| private

Referenced by draw(), getDefaultStyle(), IWORKTable(), and setHeaders().

## ◆ m_headerRowsRepeated

bool libetonyek::IWORKTable::m_headerRowsRepeated
| private

Referenced by IWORKTable(), and setRepeated().

## ◆ m_horizontalBottomLines

IWORKGridLineMap_t libetonyek::IWORKTable::m_horizontalBottomLines
| private

Referenced by draw(), IWORKTable(), and setBorders().

## ◆ m_horizontalLines

IWORKGridLineMap_t libetonyek::IWORKTable::m_horizontalLines
| private

Referenced by draw(), IWORKTable(), setBorders(), and setBorders().

## ◆ m_langManager

const IWORKLanguageManager& libetonyek::IWORKTable::m_langManager
| private

Referenced by draw(), and IWORKTable().

## ◆ m_name

boost::optional<std::string> libetonyek::IWORKTable::m_name
| private

Referenced by draw(), IWORKTable(), and setName().

## ◆ m_order

boost::optional<int> libetonyek::IWORKTable::m_order
| private

Referenced by getOrder(), IWORKTable(), and setOrder().

## ◆ m_recorder

std::shared_ptr<IWORKTableRecorder> libetonyek::IWORKTable::m_recorder
| private

Referenced by draw(), getRecorder(), insertCell(), insertCoveredCell(), IWORKTable(), setBandedRows(), setBorders(), setBorders(), setComment(), setDefaultCellStyle(), setDefaultLayoutStyle(), setDefaultParagraphStyle(), setHeaders(), setOrder(), setRecorder(), setRepeated(), setSize(), setSizes(), and setStyle().

## ◆ m_rows

unsigned libetonyek::IWORKTable::m_rows
| private

Referenced by getDefaultStyle(), IWORKTable(), and setSize().

## ◆ m_rowSizes

IWORKRowSizes_t libetonyek::IWORKTable::m_rowSizes
| private

Referenced by draw(), insertCell(), insertCoveredCell(), IWORKTable(), and setSizes().

## ◆ m_style

IWORKStylePtr_t libetonyek::IWORKTable::m_style
| private

Referenced by getStyle(), IWORKTable(), and setStyle().

## ◆ m_table

Table_t libetonyek::IWORKTable::m_table
| private

Referenced by draw(), insertCell(), insertCoveredCell(), IWORKTable(), and setSizes().

## ◆ m_tableNameMap

const IWORKTableNameMapPtr_t libetonyek::IWORKTable::m_tableNameMap
| private

Referenced by draw(), and IWORKTable().

## ◆ m_verticalLines

IWORKGridLineMap_t libetonyek::IWORKTable::m_verticalLines
| private

Referenced by draw(), IWORKTable(), setBorders(), and setBorders().

## ◆ m_verticalRightLines

IWORKGridLineMap_t libetonyek::IWORKTable::m_verticalRightLines
| private

Referenced by draw(), IWORKTable(), and setBorders().

The documentation for this class was generated from the following files:

- IWORKTable.h
- IWORKTable.cpp